/*
 * Copyright (c) 2011 by Axway Software
 * All brand or product names are trademarks or registered trademarks of their respective holders.
 * This document and the software described in this document are the property of Axway Software and are protected as Axway Software trade secrets.
 * No part of this work may be reproduced or disseminated in any form or by any means, without the prior written permission of Axway Software.
 */
package com.acme;

import java.io.InputStream;
import org.glassfish.grizzly.http.server.Request;
import org.glassfish.grizzly.http.server.Response;

/**
 *
 * @author dgay
 */
public class AsyncUpload implements Runnable
{
    private Request     req;
    private Response    res;
    
    public AsyncUpload( Request req, Response res )
    {
        this.req = req;
        this.res = res;
    }
    
    //--- Runnable implementation ----------------------------------------------
    
    @Override
    public void run()
    {
        InputStream input;
        byte[]      buffer;
        
        try
        {
            //Thread.sleep( 1000 );
            buffer = new byte[ 8*1024 ];
            input = req.getInputStream( true );
            input.read( buffer );
            
            // Simulate some time consuming operation
            Thread.sleep( 1000 );
            
            // Simulate a cancel
            res.setStatus( 500, "Oups, I'm wrong!" );
            cancelSafely();
        }
        catch( Exception ex )
        {
            //ex.printStackTrace( System.err );
        }
        
    }
    
    
    //--- Private methods ------------------------------------------------------
    
    private void cancelSafely()
    {
        try
        {
            System.out.println( "cancel the response" );
            res.cancel();
        }
        catch( Exception ex )
        {
            //ex.printStackTrace( System.err );
        }
    }
    
}
